SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'elementOnTop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:43'!
initialize


	elementOnTop := OOStackElement bottom.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:43'!
isEmpty



	^elementOnTop isBottom.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:55'!
pop 

	| oldTop |
	oldTop := elementOnTop.
	elementOnTop := elementOnTop elementBelow.
	
	^oldTop elementValue.
	

! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:49'!
push: aValue 

	| newTop |

	newTop := OOStackElement value: aValue onTopOf: elementOnTop.
	
	elementOnTop := newTop.


! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:28'!
size

	^elementOnTop amountOfElementsBelow.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:55'!
top


	^elementOnTop elementValue.! !

Object subclass: #OOStackElement
	instanceVariableNames: 'elementValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackElement class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:38'!
bottom

	^OOStackElementBottom new.! !

!OOStackElement class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:46'!
value: aValue onTopOf: anOOStackElement

	^OOStackElementValue new initializeWithValue: aValue onTopOf: anOOStackElement.! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:27'!
amountOfElementsBelow

	^self subclassResponsibility .! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:55'!
elementValue


	^elementValue ! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:41'!
isBottom

	^self subclassResponsibility .
	! !

OOStackElement subclass: #OOStackElementBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackElementBottom methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:28'!
amountOfElementsBelow 


	^0! !

!OOStackElementBottom methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:32'!
elementBelow


	Error signal: OOStack stackEmptyErrorDescription.! !

!OOStackElementBottom methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:33'!
elementValue


	Error signal: OOStack stackEmptyErrorDescription.! !

!OOStackElementBottom methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:41'!
initialize

	elementValue:=Error
	
! !

!OOStackElementBottom methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:41'!
isBottom


	^true.! !

OOStackElement subclass: #OOStackElementValue
	instanceVariableNames: 'elementBelow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackElementValue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 19:28'!
amountOfElementsBelow 

	^ 1 + elementBelow amountOfElementsBelow.! !

!OOStackElementValue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:53'!
elementBelow

	^elementBelow! !

!OOStackElementValue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:46'!
initializeWithValue: aValue onTopOf: anOOStackElement


	elementValue := aValue.
	elementBelow := anOOStackElement.
	! !

!OOStackElementValue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/30/2012 18:42'!
isBottom

	^false! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
